FROM ubuntu
RUN apt-get update -y --fix-missing
RUN apt-get upgrade -y
# Install dependencies
RUN DEBIAN_FRONTEND=noninteractive apt install -y --no-install-recommends tzdata help2man gawk libtool-bin
RUN apt install -y build-essential python3-dev git autoconf bison flex texinfo unzip wget rsync ncurses-dev
# install crosstool-ng
RUN git clone https://github.com/crosstool-ng/crosstool-ng
WORKDIR crosstool-ng 
RUN ./bootstrap
RUN ./configure --enable-local
RUN make -j
##### setup crosstool-ng to build raspi toolchain
# Setup patches for libutils (see https://forums.raspberrypi.com/viewtopic.php?t=123177)
RUN mkdir -p ./patches/binutils/2.31.1/
COPY ./129_multiarch_libpath.patch ./patches/binutils/2.31.1/
# Copy config file for the appropriate toolchain
COPY ./armv6-rpi-linux-gnueabihf.config .
RUN mv armv6-rpi-linux-gnueabihf.config .config
ENV CT_EXPERIMENTAL=y
ENV CT_ALLOW_BUILD_AS_ROOT=y
ENV CT_ALLOW_BUILD_AS_ROOT_SURE=y
# This is important and depends on the additonal linker search paths!
ENV DEB_TARGET_MULTIARCH=arm-linux-gnueabihf
# Compile the toolchain
RUN ./ct-ng build
WORKDIR /
# Remove leftovers
RUN rm -r crosstool-ng


#RUN ./configure -release -opengl es2 -device linux-rasp-pi-g++ -device-option CROSS_COMPILE=/toolchain/bin/arm-linux-gnueabihf- -sysroot sysroot -opensource -confirm-license -make libs -prefix /usr/local/qt5pi -extprefix /qt5pi -hostprefix /qt5 -v -I sysroot/usr/include/ -nomake examples -no-use-gold-linker -I sysroot/usr/include/arm-linux-gnueabihf


